INSTALL_READY_FILE=/cloud/install/install.version
INSTALL_DONE_FILE=/cloud/install/install.done
INSTALL_LOCK=/cloud/install/installing

if [ -z $1 ]
then
	echo "FATAL: No version supplied, install aborted"
	exit 1
else
	VERSION=$1
fi

echo "Installing version $VERSION"

echo $VERSION > $INSTALL_READY_FILE

mkdir $INSTALL_LOCK

sleep 1

while [ -d $INSTALL_LOCK ]
do
	echo "Waiting for install to finish..."
	sleep 10
done

RET=`cat $INSTALL_DONE_FILE`

sleep 1

/diags/busybox rm -rf $INSTALL_LOCK

sync

echo "Install completed: with return code $RET"

exit $RET
