#!/bin/sh -x

cd /root

STARTING=1
FACTORY=2
BADCONFIG=3
ERROR=4

if [ ! -e glass-ua ]
then
	echo "$ERROR|No glass-ua found" > /tmp/AC494.status
	exit 2
fi

MAC="`ifconfig esw0 | grep HWaddr | sed 's/ /|/g' | cut -d\| -f 11`"
IP="`ifconfig esw0 | grep inet | sed 's/ /|/g' | cut -d\| -f 12`"

i=1

while [ $i -lt 500 ]
do
	if [ ! -e factory_test.cfg ]
	then
		if [ ! -e glass.cfg ]
		then
			if [ -e glass.cfg.bad ]
			then
				echo "$BADCONFIG|Invalid configuration" > /tmp/AC494.status
			else
				echo "" > /tmp/AC494.status
			fi
			
			sleep 2
			continue
		else
			CFGFILE=glass.cfg
			echo "$STARTING|Starting VoIP system..." > /tmp/AC494.status
		fi
	else
		CFGFILE=factory_test.cfg
		echo "$FACTORY|Factory test mode" > /tmp/AC494.status
	fi

	# reload DSP module
    
	rmmod ac49x_dsp
	insmod /lib/modules/drivers/char/ac49x_dsp/ac49x_dsp.ko
            
	# run the glassvoip executable
                
	sleep 1
	
	cd /root

	export ANDROID_MAJOR_VERSION=`cat /root/android_major_version`
	export ANDROID_MINOR_VERSION=`cat /root/android_minor_version`
                    
	./glass-ua --config-file=$CFGFILE

	RET_CODE=$?

	DATE=`/bin/wget -t 3 -T 15 -q -O - "http://diagnostics.cloudtc.com/glassua_restarted.php?mac=$MAC&ip=$IP&ret=$RET_CODE"`

	if [ -z "$DATE" ]
	then
		DATE=`date`
	fi

	echo "glass-ua restarted on $DATE" >> /tmp/glass-ua-restarted.log

	if [ $RET_CODE -eq 999 ]
	then
		reboot
	fi
	
	if [ $RET_CODE -eq 111 ]
	then
		mv glass.cfg glass.cfg.bad
		echo "$BADCONFIG|Invalid configuration" > /tmp/AC494.status
	fi

	echo "$ERROR|VoIP system stopped with error $RET_CODE" > /tmp/AC494.status
	
	i=`expr $i + 1`
done

if [ -e reboot.count ]
then
	reboot_count=`cat reboot.count`
else
	reboot_count=0
fi

if [ $reboot_count -lt 2 ]
then
	reboot_count=`expr $reboot_count + 1`
	echo $reboot_count > reboot.count
	echo ">>>>>> Going to REBOOT in 10 secs..."
	sleep 10
	echo ">>>>>> REBOOT COUNT $reboot_count, REBOOTING"
	reboot
else
	echo ">>>>>> REBOOT COUNT $reboot_count, reached max, NOT REBOOTING"
	
	rm reboot.count
fi

